import Vue from 'vue';

var originalInit = Vue.prototype._init;
function createServerPlugin() {
    var uid = 0;
    var serverPlugin = function (Vue) {
        Vue.prototype._init = function (options) {
            this.$$uid = uid++;
            originalInit.call(this, options);
        };
        Vue.prototype.$createFetcher = function (fetcher) {
            var vm = this;
            return function (params) {
                var p = fetcher(params);
                vm.$$promises.push(p);
                return p;
            };
        };
        Vue.mixin({
            serverPrefetch: function () {
                return Promise.all(this.$$promises);
            },
            data: function () {
                this.$$promises = [];
                return {};
            },
            created: function () {
                var $$selfStore = this.$root.$$selfStore || (this.$root.$$selfStore = {});
                $$selfStore[this.$$uid] = this.$data;
            }
        });
    };
    // reset
    serverPlugin.done = function () { return (uid = 0); };
    return serverPlugin;
}
var clientPlugin = function (Vue) {
    Vue.prototype.$createFetcher = function (fetcher) {
        return function (params) {
            if (!clientPlugin.$$resolved) {
                var err = new Error('vue-ssr-prefetcher: custom error');
                err.isVueSsrPrefetcher = true;
                throw err;
            }
            return fetcher(params);
        };
    };
    Vue.mixin({
        created: function () {
            var $$selfStore = this.$root.$$selfStore;
            if (clientPlugin.$$resolved || !$$selfStore)
                return;
            Object.assign(this, $$selfStore[this._uid] || {});
        },
        errorCaptured: function (err) {
            if (err.isVueSsrPrefetcher)
                return false;
            return true;
        }
    });
};
clientPlugin.$$resolved = false;

export { clientPlugin, createServerPlugin };
